// #===========================================================================
// #
// #    context.S
// #
// #    ZYLIN context switch code
// #
// #===========================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
// #===========================================================================
// ######DESCRIPTIONBEGIN####
// #
// # Author(s):    nickg, gthomas
// # Contributors: nickg, gthomas
// # Date:         1998-09-15
// # Purpose:      ZYLIN context switch code
// # Description:  This file contains implementations of the thread context 
// #               switch routines. It also contains the longjmp() and setjmp()
// #               routines.
// #
// #####DESCRIPTIONEND####
// #
// #===========================================================================

#include <pkgconf/hal.h>

#include "zylin.inc"

        .text


;; By using a macro, we get multiple breakpoint sites
	.macro LOAD_STATE 
	popsp	
	; stack pointer now points to beginning of HAL_SavedRegisters
	; we now pop the state of the CPU

	; this will restore r0-r3
	im 0
	store		
	im 4	
	store		
	im 8
	store		
	im 12
	store		
	im 16
	store		
	im 20
	store		
	im 24
	store		
	im 28
	store		
	
	;; restore interrupts 
	im INTERRUPT_ENABLE
	load
	store


	.endm


// ----------------------------------------------------------------------------
//  hal_thread_switch_context
//  Switch thread contexts

	    
	.globl hal_thread_switch_context
hal_thread_switch_context:

	;; save interrupt state
	im INTERRUPT_ENABLE
	load
	load

	; store current state on stack
	im 28
	load
	im 24
	load
	im 20
	load
	im 16
	load
	im 12
	load
	im 8 
	load
	im 4
	load
	im 0
	load
	

	;; store pointer to SP in "from" pointer
	pushsp
	pushsp
	im 8+8*4+4+4
	add
	load
	store		

	;; put pointer to '*to' on stack
	pushsp
	im 4+8*4+4
	add
	load
	load

	LOAD_STATE

	poppc			; voila! jump to saved pc
	
	
		
        
// ----------------------------------------------------------------------------
//  hal_thread_load_context
//  Load thread context

	.globl hal_thread_load_context
hal_thread_load_context:
	pushsp
	im 4
	add
	load
	load			; pointer to HAL_SavedRegisters on stack

load_state_internal:	
	LOAD_STATE
	
	poppc			; voila! jump to saved pc

// ----------------------------------------------------------------------------
//  HAL longjmp, setjmp implementations

	.globl hal_setjmp
hal_setjmp:	
	.byte 0

        
	.globl hal_longjmp
 hal_longjmp:	
	.byte 0

// ----------------------------------------------------------------------------
//  end of context.S
